/*
 * $Id: FeatConfig.java,v 1.2 2006/04/20 15:35:29 sugimotokenichi Exp $
 * Copyright (C) 2005 SUGIMOTO Ken-ichi
 * 쐬: 2006/02/17
 */
package feat2.config;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;

import feat2.FeatError;
import feat2.FeatErrors;
import feat2.config.type.Identifier;

/**
 * featݒt@C̏B
 * @author SUGIMOTO Ken-ichi
 */
public class FeatConfig extends Config {

    /** validate\bhĂ΂܂łfeatureۊǂĂ */
    private ArrayList featureList;
    /** validate\bhFeatureConfig̃}bvɈڂς */
    private HashMap features;
    private Resources resources;
    private FileLocator configFileLocator;
    private FileLocator appRootLocator;
    private boolean useBodyEncodingForURI;

    public FeatConfig() {
        featureList = new ArrayList();
        features = null;
        resources = new Resources();
        useBodyEncodingForURI = false;
    }

    public void addFeatureConfig(FeatureConfig feature) {
        featureList.add(feature);
        feature.setParent(this);
    }

    /**
     * tB[`[̐ݒԂB
     * @param featureName
     * @return
     * @throws IllegalStateException validate\bhĂ΂OgetFeatureConfig\bhĂ΂ꂽƂɃX[
     */
    public FeatureConfig getFeatureConfig(String featureName) throws IllegalStateException{
        if ( features == null )
            throw new IllegalStateException("validate\bhĂ΂OgetFeatureConfig\bhĂ΂܂");
        return (FeatureConfig)features.get(featureName);
    }

    public void addResources(Resources resources) {
        this.resources.addResources(resources);
    }

    public String getStringResource(String resourceName, Locale locale) {
        return resources.getString(resourceName, locale);
    }

    public Resources getResources() {
        return resources;
    }

    public Iterator getFeatures() {
        return featureList.iterator();
    }

    // vpeB -------------------------------------------------------------

    public FileLocator getAppRootLocator() {
        return appRootLocator;
    }
    public void setAppRootLocator(FileLocator appRootLocator) {
        this.appRootLocator = appRootLocator;
    }

    public FileLocator getConfigFileLocator() {
        return configFileLocator;
    }
    public void setConfigFileLocator(FileLocator configFileLocator) {
        this.configFileLocator = configFileLocator;
    }

    public Identifier getName() {
        return null;
    }

    public boolean isUseBodyEncodingForURI() {
        return useBodyEncodingForURI;
    }

    public void setUseBodyEncodingForURI(boolean useBodyEncodingForURI) {
        this.useBodyEncodingForURI = useBodyEncodingForURI;
    }


    // Config̃\bh -------------------------------------------------------

    public String getElementName() {
        return "feat";
    }

    public boolean validate(FeatErrors errs) {

        boolean ret = true;

        if ( !useBodyEncodingForURI )
            errs.add( new ConfigError(null, "warn.config.feat.useBodyEncodingForURI.false", FeatError.WARN, this) );

        features = new HashMap();
        for (Iterator iter = featureList.iterator(); iter.hasNext();) {
            FeatureConfig featureConf = (FeatureConfig) iter.next();
            features.put(featureConf.getName().getValue(), featureConf);
        }

        ret = ( ret && ConfigUtil.validate(featureList.iterator(), errs) );

        if ( configFileLocator == null )
            throw new ConfigurationException("exception.config.feat.configFileLocator.null");
        if ( appRootLocator == null )
            throw new ConfigurationException("exception.config.feat.appRootLocator.null");

        return ret;
    }


}
